<template>
  <div class="flex flex-col">
    <div class="flex justify-center">
      <div class="text-xl text-white w-[40rem]">
        {{ question_str }}
      </div>
    </div>
    <div class="flex mt-4 justify-center items-center">
      <div class="inline-block">
        <a-input label="Lodge id:" placeholder="lodge id"
          :validators="numberValidators" v-model="lodge_id" />
        <submit-button value="find" @click="execute" />
      </div>
      <sql-query-text>{{ sql_query }}</sql-query-text>
    </div>
    <div class="flex justify-center">
      <Events />
    </div>

  </div>
</template>

<script>
import AInput from '@/components/AInput.vue';
import { letterNamesValidator, positiveNumberValidator } from '@/components/Validators.js'
import SubmitButton from '@/components/SubmitButton.vue';
import TableBase from '@/components/TableBase.vue';
import ComplexSqlQueries from '@/assets/ComplexQueries.json';
import SqlQueryText from '@/components/SqlQueryText.vue';
import Events from '@/components/Events.vue';
import { mapMutations } from 'vuex';
import axiosClient from '@/axiosClient';
import { add_events } from '@/components/helpers';

export default {
  components: {
    AInput,
    SubmitButton,
    TableBase,
    SqlQueryText,
    Events
  },
  data() {
    return {
      numberValidators: [positiveNumberValidator],
      question_str: ComplexSqlQueries[2].question,
      sql_query: ComplexSqlQueries[2].query,
      lodge_id: undefined,
    }
  },
  methods: {
    ...mapMutations(['clearEvents']),
    execute() {
      axiosClient.get('complex-query/3', {headers: {n: this.lodge_id}})
      .then((response) => {
        this.clearEvents()
        add_events(response)
      })
    }
  },
  mounted() {
    this.clearEvents()
  }
}


</script>